/*********************************************
 *                                           *
 * setlookup.h                               *
 *                                           *
 * Interface for a integer hash table which  *
 *    uses quadratic probing                 *
 *                                           *
 *  Author:  David Bunde                     *
 *    Date:  07 Apr 99                       *
 *                                           *
 *********************************************/

#include "closehash.h"

#ifndef __SETLOOKUP_H__
#define __SETLOOKUP_H__

//
// Class: SetLookup
// Derived from: QuadHashTable<int, Etype>
//
// A concrete class which hashes using an integer key
//
template<class Etype>
class SetLookup : public QuadHashTable<int,Etype>
{
protected:
  int HashFunction(int key);	//the hash function
};

#endif
